// material-ui
import {
    Button,
    Grid, TextField,
    Autocomplete,
    Typography
} from '@mui/material';
import MainCard from "components/MainCard";
import OrgComboAutocomplete from "components/OrgComboAutocomplete";
import { useForm } from "react-hook-form";
import * as React from "react";
import * as ComboData from "utils/ComboData";
import * as DateUtils from "utils/DateUtils";
import * as FormatUtils from "utils/FormatUtils";
import {PNSPS_BUTTON_THEME} from "../../../themes/buttonConst";
import {ThemeProvider} from "@emotion/react";
import { useIntl } from "react-intl";

import {DatePicker} from "@mui/x-date-pickers/DatePicker";
import dayjs from "dayjs";
import {DemoItem} from "@mui/x-date-pickers/internals/demo";
import {LocalizationProvider} from "@mui/x-date-pickers/LocalizationProvider";
import {AdapterDayjs} from "@mui/x-date-pickers/AdapterDayjs";
// ==============================|| DASHBOARD - DEFAULT ||============================== //
const SearchDemandNoteForm = ({ applySearch, searchCriteria, issueComboData, onGridReady
}) => {

    const [type, setType] = React.useState([]);
    const [orgSelected, setOrgSelected] = React.useState({});
    const [issueSelected, setIssueSelected] = React.useState({});
    const [issueCombo, setIssueCombo] = React.useState([]);
    const [selectedStatus, setSelectedStatus] = React.useState(ComboData.denmandNoteStatus[0]);

    const [minDate, setMinDate] = React.useState(searchCriteria.dateFrom);
    const [maxDate, setMaxDate] = React.useState(searchCriteria.dateTo);
    const [fromDateValue, setFromDateValue] = React.useState(searchCriteria.dateFrom);
    const [toDateValue, setToDateValue] = React.useState(searchCriteria.dateTo);
    
    const [minDueDate, setMinDueDate] = React.useState(null);
    const [maxDueDate, setMaxDueDate] = React.useState(null);
    const [fromDueDateValue, setFromDueDateValue] = React.useState(null);
    const [toDueDateValue, setToDueDateValue] = React.useState(null);

    const intl = useIntl();
    const { locale } = intl;
    
    React.useEffect(() => {
        if(searchCriteria.status!=undefined){
            if(searchCriteria.status === ""){
                ComboData.denmandNoteStatus[0]
            }else{
                setSelectedStatus(ComboData.denmandNoteStatus.find(item => item.type === searchCriteria.status))
            }
            if(searchCriteria.dueDateFrom != ""){
                setMinDueDate(DateUtils.dateValue(searchCriteria.dueDateFrom))
            }else{
                setMinDueDate(null)
            }
            if(searchCriteria.dueDateTo != ""){
                setMaxDueDate(DateUtils.dateValue(searchCriteria.dueDateTo))
            }else{
                setMaxDueDate(null);
            }
        }else{
            setSelectedStatus(ComboData.denmandNoteStatus[0])      
        }
    }, [searchCriteria]);
    
    React.useEffect(() => {
        setFromDateValue(minDate);
    }, [minDate]);

    React.useEffect(() => {
        setToDateValue(maxDate);
    }, [maxDate]);

    React.useEffect(() => {
        setFromDueDateValue(minDueDate);
    }, [minDueDate]);

    React.useEffect(() => {
        setToDueDateValue(maxDueDate);
    }, [maxDueDate]);

    const { reset, register, handleSubmit } = useForm()
    const onSubmit = (data) => {
        data.status = selectedStatus?.type;
        let typeArray = [];
        let sentDateFrom = "";
        let sentDateTo = "";
        let sentDueDateFrom = "";
        let sentDueDateTo = "";

        for (let i = 0; i < type.length; i++) {
            typeArray.push(type[i].label);
        }

        if (fromDateValue != "dd / mm / yyyy" && toDateValue != "dd / mm / yyyy") {
            sentDateFrom = DateUtils.dateValue(fromDateValue)
            sentDateTo = DateUtils.dateValue(toDateValue)
        }

        if (fromDueDateValue != "dd / mm / yyyy" && toDueDateValue != "dd / mm / yyyy") {
            sentDueDateFrom = DateUtils.dateValue(fromDueDateValue)
            sentDueDateTo = DateUtils.dateValue(toDueDateValue)
        }

        const temp = {
            appNo: data.appNo,
            issueId: issueSelected?.id,
            orgId: (orgSelected?.key && orgSelected?.key > 0) ? orgSelected?.key : "",
            dnNo: data.dnNo,
            dateFrom: sentDateFrom,
            dateTo: sentDateTo,
            dueDateFrom: sentDueDateFrom,
            dueDateTo: sentDueDateTo,
            status: (data?.status === '' || data?.status?.includes("all")) ? "" : data.status,
            start:0,
            limit:10
        };
        applySearch(temp);
    };


    React.useEffect(() => {
        if (issueComboData && issueComboData.length > 0) {
            setIssueCombo(issueComboData);
            if(searchCriteria.issueId!=undefined){
                setIssueSelected(issueComboData.find(item => item.id === searchCriteria.issueId))
            }
        }
    }, [issueComboData]);

    function resetForm() {
        setType([]);
        setOrgSelected({});
        setIssueSelected({});
        setSelectedStatus(ComboData.denmandNoteStatus[0]);
        setMinDueDate(null);
        setMaxDueDate(null);
        setMinDate(DateUtils.dateValue(new Date().setDate(new Date().getDate()-14)))
        setMaxDate(DateUtils.dateValue(new Date()))
        reset({
            appNo:"",
            dnNo:"",
        });
        localStorage.setItem('searchCriteria',"")
    }

    function getIssueLabel(data) {
        let issueYear = data.issueYear
        let volume = data.volume;
        let issueNo = data.issueNo;
        let issueDate = data.issueDate;
        if (locale === 'zh-HK') {
            return issueYear
                + " 第" + volume + "卷,"
                + " 第" + issueNo + "期,"
                + " " + DateUtils.dateFormat(issueDate, "YYYY年MM月DD日")
                + " (" + DateUtils.getWeekdayStr_ZH(issueDate) + ")";
        } else if (locale === 'zh-CN') {
            return issueYear
                + " 第" + volume + "卷,"
                + " 第" + issueNo + "期,"
                + " " + DateUtils.dateFormat(issueDate, "YYYY年MM月DD日")
                + " (" + DateUtils.getWeekdayStr_CN(issueDate) + ")";
        }
        return issueYear
            + " Vol. " + FormatUtils.zeroPad(volume, 3)
            + ", No. " + FormatUtils.zeroPad(issueNo, 2)
            + ", " + DateUtils.dateFormat(issueDate, "D MMM YYYY (ddd)");
    }

    return (
        <MainCard xs={12} md={12} lg={12}
            border={false}
            content={false}
            sx={{ backgroundColor: '#fff' }}
        >

            <form onSubmit={handleSubmit(onSubmit)}>
                <Grid container sx={{ backgroundColor: '#ffffff', ml: 2, mt: 1 }} width="98%">
                    {/*row 1*/}
                    <Grid item justifyContent="space-between" alignItems="center" sx={{mt:1, ml:3,mb:2.5}}>
                        <Typography variant="pnspsFormHeader" >
                            Search
                        </Typography>
                    </Grid>
                    {/*row 2*/}
                    <Grid container display="flex" alignItems={"center"}>

                        <Grid item xs={9} s={6} md={5} lg={3} sx={{ ml: 3, mr: 3, mb: 3 }}>
                            <Autocomplete
                                {...register("issueId")}
                                disablePortal
                                id="issueId"
                                size="small"
                                options={issueCombo}
                                value={issueSelected}
                                inputValue={(issueSelected?.id) ? getIssueLabel(issueSelected) : ""}
                                getOptionLabel={(option) => getIssueLabel(option)}
                                onChange={(event, newValue) => {
                                    setIssueSelected(newValue);
                                }}
                                sx={{
                                    '& .MuiInputBase-root': { alignItems: 'center' },
                                    '& .MuiAutocomplete-endAdornment': { top: '50%', transform: 'translateY(-50%)' },
                                    '& .MuiOutlinedInput-root': { height: 40 }
                                }}
                                renderInput={(params) => (
                                    <TextField {...params}
                                        label="Gazette Issue No."
                                        InputLabelProps={{
                                            shrink: true
                                        }}
                                    />
                                )}
                                clearText={intl.formatMessage({ id: "muiClear" })}
                                closeText={intl.formatMessage({ id: "muiClose" })}
                                openText={intl.formatMessage({ id: "muiOpen" })}
                                noOptionsText={intl.formatMessage({ id: "muiNoOptions" })}
                            />
                        </Grid>

                        <Grid item xs={9} s={6} md={5} lg={3} sx={{ ml: 3, mr: 3, mb: 3 }}>
                            <TextField
                                fullWidth
                                {...register("appNo")}
                                id='appNo'
                                label={"Application No."}
                                defaultValue={searchCriteria.appNo}
                                InputLabelProps={{
                                    shrink: true
                                }}
                            />
                        </Grid>

                        <Grid item xs={9} s={6} md={5} lg={3} sx={{ ml: 3, mr: 3, mb: 3 }}>
                            <OrgComboAutocomplete
                                register={register}
                                value={orgSelected?.key ? orgSelected : null}
                                initialOrgId={searchCriteria.orgId}
                                onChange={(newValue) => {
                                    setOrgSelected(newValue ?? {});
                                }}
                                clearText={intl.formatMessage({ id: "muiClear" })}
                                closeText={intl.formatMessage({ id: "muiClose" })}
                                openText={intl.formatMessage({ id: "muiOpen" })}
                                noOptionsText={intl.formatMessage({ id: "muiNoOptions" })}
                            />
                        </Grid>

                        <Grid item xs={9} s={6} md={5} lg={3} sx={{ ml: 3, mr: 3, mb: 3 }}>
                            <TextField
                                fullWidth
                                {...register("dnNo")}
                                id='dnNo'
                                label="DN No."
                                defaultValue={searchCriteria.dnNo}
                                InputLabelProps={{
                                    shrink: true
                                }}
                            />
                        </Grid>

                        <Grid item xs={9} s={6} md={5} lg={3} sx={{ml:3, mr:3, mb:3}}>
                            <Grid container spacing={1}>
                                <Grid item xs={6}>
                                    <LocalizationProvider dateAdapter={AdapterDayjs}>
                                        <DemoItem  components={['DatePicker']}>
                                            <DatePicker
                                                id="dateFrom"
                                                // onError={(newError) => setReceiptFromError(newError)}
                                                slotProps={{
                                                    field: { readOnly: true, },
                                                    // textField: {
                                                    //     helperText: receiptFromErrorMessage,
                                                    // },
                                                }}
                                                format="DD/MM/YYYY"
                                                label={"Issue Date (From)"}
                                                value={minDate === null ? null : dayjs(minDate)}
                                                maxDate={maxDate === null ? null : dayjs(maxDate)}
                                                onChange={(newValue) => {
                                                    // console.log(newValue)
                                                    if(newValue!=null){
                                                        setMinDate(newValue);
                                                    }
                                                }}
                                            />
                                        </DemoItem >
                                    </LocalizationProvider>
                                </Grid>

                                <Grid item xs={6}>           
                                    <LocalizationProvider dateAdapter={AdapterDayjs}>
                                        <DemoItem  components={['DatePicker']}>
                                            <DatePicker
                                                id="dateTo"
                                                // onError={(newError) => setReceiptFromError(newError)}
                                                slotProps={{
                                                    field: { readOnly: true, },
                                                    // textField: {
                                                    //     helperText: receiptFromErrorMessage,
                                                    // },
                                                }}
                                                format="DD/MM/YYYY"
                                                label={"Issue Date (To)"}
                                                value={maxDate === null ? null : dayjs(maxDate)}
                                                minDate={minDate === null ? null : dayjs(minDate)}
                                                onChange={(newValue) => {
                                                    // console.log(newValue)
                                                    if(newValue!=null){
                                                        setMaxDate(newValue);
                                                    }
                                                }}
                                            />
                                        </DemoItem >
                                    </LocalizationProvider>
                                </Grid>
                            </Grid>
                        </Grid>

                        <Grid item xs={9} s={6} md={6} lg={3.5} sx={{ml:3, mr:2, mb:3}}>
                            <Grid container spacing={1}>
                                <Grid item xs={6}>
                                    <LocalizationProvider dateAdapter={AdapterDayjs}>
                                        <DemoItem  components={['DatePicker']}>
                                            <DatePicker
                                                id="dueDateFrom"
                                                // onError={(newError) => setReceiptFromError(newError)}
                                                slotProps={{
                                                    field: { readOnly: true, },
                                                    textField: {
                                                        // helperText: receiptFromErrorMessage,
                                                        InputLabelProps: { shrink: true }
                                                    },
                                                }}
                                                format="DD/MM/YYYY"
                                                label={"Due Date (From)"}
                                                value={minDueDate === null ? null : dayjs(minDueDate)}
                                                maxDate={maxDueDate === null ? null : dayjs(maxDueDate)}
                                                onChange={(newValue) => {
                                                    // console.log(newValue)
                                                    setMinDueDate(newValue);
                                                }}
                                            />
                                        </DemoItem >
                                    </LocalizationProvider>
                                </Grid>

                              
                                <Grid item xs={6}>                                    
                                    <LocalizationProvider dateAdapter={AdapterDayjs}>
                                        <DemoItem  components={['DatePicker']}>
                                            <DatePicker
                                                id="dueDateTo"
                                                // onError={(newError) => setReceiptFromError(newError)}
                                                slotProps={{
                                                    field: { readOnly: true, },
                                                    textField: {
                                                        // helperText: receiptFromErrorMessage,
                                                        InputLabelProps: { shrink: true }
                                                    },
                                                }}
                                                format="DD/MM/YYYY"
                                                label={"Due Date (To)"}
                                                value={maxDueDate === null ? null : dayjs(maxDueDate)}
                                                minDate={minDueDate === null ? null : dayjs(minDueDate)}
                                                onChange={(newValue) => {
                                                    // console.log(newValue)
                                                    setMaxDueDate(newValue);
                                                }}
                                            />
                                        </DemoItem >
                                    </LocalizationProvider>
                                </Grid>
                            </Grid>
                        </Grid>


                        <Grid item xs={9} s={6} md={5} lg={3} sx={{ ml: 3, mr: 3, mb: 3 }}>
                            <Autocomplete
                                size="small"
                                {...register("status")}
                                id="status"
                                options={ComboData.denmandNoteStatus}
                                value={selectedStatus}
                                onChange={(event, newValue) => {
                                    if(newValue==null){
                                        setSelectedStatus(ComboData.denmandNoteStatus[0]);
                                    }else{
                                        setSelectedStatus(newValue);
                                    }
                                }}
                                sx={{
                                    '& .MuiInputBase-root': { alignItems: 'center' },
                                    '& .MuiAutocomplete-endAdornment': { top: '50%', transform: 'translateY(-50%)' },
                                    '& .MuiOutlinedInput-root': { height: 40 }
                                }}
                                getOptionLabel={(option) => (option?.label != null ? String(option.label) : "")}
                                renderInput={(params) => (
                                    <TextField
                                        {...params}
                                        label="Status"
                                        InputLabelProps={{
                                            shrink: true
                                        }}
                                    />
                                )}
                                clearText={intl.formatMessage({ id: "muiClear" })}
                                closeText={intl.formatMessage({ id: "muiClose" })}
                                openText={intl.formatMessage({ id: "muiOpen" })}
                                noOptionsText={intl.formatMessage({ id: "muiNoOptions" })}
                            />
                        </Grid>



                    </Grid>

                    {/*last row*/}
                    <Grid container maxWidth justifyContent="flex-end">
                        <ThemeProvider theme={PNSPS_BUTTON_THEME}>
                        <Grid item sx={{ ml: 3, mb:3 }}>
                            <Button
                                variant="contained"
                                color="cancel"
                                onClick={resetForm}
                                >
                                Reset
                            </Button>
                        </Grid>

                        <Grid item sx={{ ml: 3, mr: 3, mb:3}}>
                            <Button
                                variant="contained"
                                type="submit"
                                disabled={onGridReady}
                            >
                                Submit
                            </Button>
                        </Grid>
                        </ThemeProvider>
                    </Grid>
                </Grid>
            </form>
        </MainCard>
    );
};

export default SearchDemandNoteForm;
